const Descontos = require("../infra/repository/descontos.repository");
const descontos = new Descontos();

class descontosController {
 


    register() {
        return function (req, res) {
            const  data  = req.body;
            const id_user = req.query.id_user;
 
            descontos.register(data, id_user).then((response) => {
                if (response.error) return res.status(response.code).send({ error: response.error });
                else return res.status(200).json(response);
            }).catch((error) => {
                return res.status(400).send({ error: `Não foi possível realizar o cadastro!` });
            });
        };
    }

   
 
     list() {
        return function (req, res) {
            const { id } = req.params;
            

            descontos.list(id).then((response) => {
                if (response.error) res.status(response.code).send({ error: response.error });
                else return res.status(200).send(response);
            }).catch((error) => {
                throw new Error(error);
            });
        }
    }


    listDescontosByUser() {
        return function (req, res) {
            const id_user  = req.query.id_user;
            

            descontos.listDescontosByUser(id_user).then((response) => {
                if (response.error) res.status(response.code).send({ error: response.error });
                else return res.status(200).send(response);
            }).catch((error) => {
                throw new Error(error);
            });
        }
    }

    delete() {
        return function (req, res) {
            const { id } = req.params;
            
            descontos.delete(id).then((response) => {
                if (response.error) res.status(response.code).send(response);
                else return res.status(200).send(response);
            }).catch((error) => {
                throw new Error(error);
            });
        }
    }


    update() {
        return function (req, res) {
            const  data  = req.body;
            const id_user = req.query.id_user;
            
            descontos.update(data, id_user).then((response) => {
                if (response.error) res.status(400).send(response);
                else return res.status(200).send(response);
            }).catch((error) => {
                throw new Error(error);
            });
        }
    }

}

module.exports = descontosController;