const Distribuidor = require("../infra/repository/distribuidores.repository");
const distribuidores = new Distribuidor();

class distribuidoresController {
 

    /**
     * Registra um usuário
     * @returns mensagem referente ao resultado obtido
     */
    register() {
        return function (req, res) {
            const  data  = req.body;
            
            distribuidores.register(data).then((response) => {
                if (response.error) return res.status(response.code).send({ error: response.error });
                else return res.status(response.code).json(response);
            }).catch((error) => {
                return res.status(400).send({ error: `Não foi possível realizar o cadastro!` });
            });
        };
    }

   
    /**
     * Lista todos os usuario
     * @returns mensagem referente ao resultado obtido
     */
     list() {
        return function (req, res) {
            const { id } = req.params;

            distribuidores.list(id).then((response) => {
                if (response.error) res.status(response.code).send({ error: response.error });
                else return res.status(200).send(response);
            }).catch((error) => {
                throw new Error(error);
            });
        }
    }


    /**
     * Delete um usuário
     * @returns mensagem referente ao resultado obtido
     */
    delete() {
        return function (req, res) {
            const { id } = req.params;
            
            distribuidores.delete(id).then((response) => {
                if (response.error) res.status(response.code).send(response);
                else return res.status(200).send(response);
            }).catch((error) => {
                throw new Error(error);
            });
        }
    }



    /**
     * Atualiza os dados de um usuário
     * @returns mensagem referente ao resultado obtido
     */
    update() {
        return function (req, res) {
            const data = req.body;
            
            distribuidores.update(data).then((response) => {
                if (response.error) res.status(400).send(response);
                else return res.status(200).send(response);
            }).catch((error) => {
                throw new Error(error);
            });
        }
    }




  
}

module.exports = distribuidoresController;