const Metas = require("../infra/repository/metas.repository");
const metas = new Metas();

class metasController {
 


    register() {
        return function (req, res) {
            const  data  = req.body;

            metas.register(data).then((response) => {
                if (response.error) return res.status(response.code).send({ error: response.error });
                else return res.status(200).json(response);
            }).catch((error) => {
                return res.status(400).send({ error: `Não foi possível realizar o cadastro!` });
            });
        };
    }

   
 
     list() {
        return function (req, res) {
            

            metas.list().then((response) => {
                if (response.error) res.status(response.code).send({ error: response.error });
                else return res.status(200).send(response);
            }).catch((error) => {
                throw new Error(error);
            });
        }
    }





    delete() {
        return function (req, res) {
            const { id } = req.params;
            
            metas.delete(id).then((response) => {
                if (response.error) res.status(response.code).send(response);
                else return res.status(200).send(response);
            }).catch((error) => {
                throw new Error(error);
            });
        }
    }


    update() {
        return function (req, res) {
            const  data  = req.body;
            
            metas.update(data).then((response) => {
                if (response.error) res.status(400).send(response);
                else return res.status(200).send(response);
            }).catch((error) => {
                throw new Error(error);
            });
        }
    }

}

module.exports = metasController;